## mingw-w64-waf-2.1.5-1.src.tar.zst

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2005-2018

"""
to make a custom waf file use the option --tools

To add a tool that does not exist in the folder compat15, pass an absolute path:
./waf-light  --tools=compat15,/comp/waf/aba.py --prelude=$'\tfrom waflib.extras import aba\n\taba.foo()'
"""

VERSION="2.1.5"
APPNAME='waf'
REVISION=''

top = '.'
out = 'build'

zip_types = ['bz2', 'gz', 'xz']

PRELUDE = ''

import os, sys, re, io, optparse, tokenize
from hashlib import md5

from waflib import Errors, Utils, Options, Logs, Scripting
from waflib import Configure
Configure.autoconfig = 1

def sub_file(fname, lst):
	with open(fname, 'r') as f:
		txt = f.read()

	for (key, val) in lst:
		re_pat = re.compile(key, re.M)
		txt = re_pat.sub(val, txt)

	with open(fname, 'w') as f:
		f.write(txt)

def to_bytes(x):
	if sys.hexversion>0x300000f:
		return x.encode()
	return x

Logs.warn('------> Executing code from the top-level wscript <-----')
def init(ctx):
	if Options.options.setver: # maintainer only (ita)
		ver = Options.options.setver
		hexver = Utils.num2ver(ver)
		hexver = '0x%x'%hexver
		sub_file('wscript', (('^VERSION=(.*)', 'VERSION="%s"' % ver), ))
		sub_file('waf-light', (('^VERSION=(.*)', 'VERSION="%s"' % ver), ))

		pats = []
		pats.append(('^WAFVERSION=(.*)', 'WAFVERSION="%s"' % ver))
		pats.append(('^HEXVERSION(.*)', 'HEXVERSION=%s' % hexver))

		try:
			rev = ctx.cmd_and_log("git rev-parse HEAD").strip()
		except Errors.WafError:
			rev = ''
		else:
			pats.append(('^WAFREVISION(.*)', 'WAFREVISION="%s"' % rev))

		sub_file('waflib/Context.py', pats)

		sys.exit(0)

def check(ctx):
	Logs.warn('Nothing to do')

# this function is called before any other for parsing the command-line
def options(opt):

	# generate waf
	opt.add_option('--make-waf', action='store_true', default=True,
		help='creates the waf script', dest='waf')

	opt.add_option('--interpreter', action='store', default=None,
		help='specify the #! line on top of the waf file', dest='interpreter')

	opt.add_option('--sign', action='store_true', default=False, help='make a signed file', dest='signed')

	default_zip = 'bz2'
	if os.name == 'java':
		default_zip = 'gz'
	opt.add_option('--zip-type', action='store', default=default_zip,
		help='specify the zip type [Allowed values: %s]' % ' '.join(zip_types), dest='zip')

	opt.add_option('--make-batch', action='store_true', default=False,
		help='creates a convenience waf.bat file (done automatically on win32 systems)',
		dest='make_batch')

	opt.add_option('--yes', action='store_true', default=False,
		help=optparse.SUPPRESS_HELP,
		dest='yes')

	# those ones are not too interesting
	opt.add_option('--set-version', default='',
		help='sets the version number for waf releases (for the maintainer)', dest='setver')
	opt.add_option('--set-name', default='waf', help=optparse.SUPPRESS_HELP, dest='wafname')

	opt.add_option('--strip', action='store_true', default=True,
		help='shrinks waf (strip docstrings, saves 33kb)',
		dest='strip_comments')
	opt.add_option('--nostrip', action='store_false', help='no shrinking',
		dest='strip_comments')
	opt.add_option('--tools', action='store', help='Comma-separated 3rd party tools to add, eg: "compat,ocaml" [Default: "compat15"]',
		dest='add3rdparty', default='compat15')
	opt.add_option('--coretools', action='store', help='Comma-separated core tools to add, eg: "vala,tex" [Default: all of them]',
		dest='coretools', default='default')
	opt.add_option('--prelude', action='store', help='Code to execute before calling waf', dest='prelude', default=PRELUDE)
	opt.add_option('--namesfrom', action='store', help='Obtain the file names from a model archive', dest='namesfrom', default=None)
	opt.load('python')

def process_tokens(tokens):
	accu = []
	prev = tokenize.NEWLINE

	indent = 0
	line_buf = []

	for (type, token, start, end, line) in tokens:
		token = token.replace('\r\n', '\n')
		if type == tokenize.NEWLINE:
			if line_buf:
				accu.append(indent * '\t')
				ln = "".join(line_buf)
				if ln == 'if __name__=="__main__":': break
				#ln = ln.replace('\n', '')
				accu.append(ln)
				accu.append('\n')
				line_buf = []
				prev = tokenize.NEWLINE
		elif type == tokenize.INDENT:
			indent += 1
		elif type == tokenize.DEDENT:
			indent -= 1
		elif type == tokenize.NAME:
			if prev == tokenize.NAME or prev == tokenize.NUMBER: line_buf.append(' ')
			line_buf.append(token)
		elif type == tokenize.NUMBER:
			if prev == tokenize.NAME or prev == tokenize.NUMBER: line_buf.append(' ')
			line_buf.append(token)
		elif type == tokenize.STRING:
			if not line_buf and token.startswith('"'): pass
			else: line_buf.append(token)
		elif type == tokenize.COMMENT:
			pass
		elif type == tokenize.OP:
			line_buf.append(token)
		else:
			if token != "\n": line_buf.append(token)

		if token != '\n':
			prev = type

	body = ''.join(accu)
	return body

deco_re = re.compile('(def|class)\\s+(\\w+)\\(.*')
def process_decorators(body):
	lst = body.splitlines()
	accu = []
	all_deco = []
	buf = [] # put the decorator lines
	for line in lst:
		if line.startswith('@'):
			buf.append(line[1:])
		elif buf:
			name = deco_re.sub('\\2', line)
			if not name:
				raise IOError("decorator not followed by a function!" + line)
			for x in buf:
				all_deco.append('%s(%s)' % (x, name))
			accu.append(line)
			buf = []
		else:
			accu.append(line)
	return '\n'.join(accu+all_deco)

def sfilter(path):
	if path.endswith('.py') :
		if Options.options.strip_comments:
			if sys.version_info[0] >= 3:
				with open(path, 'rb') as f:
					tk = tokenize.tokenize(f.readline)
					next(tk) # the first one is always tokenize.ENCODING for Python 3, ignore it
					cnt = process_tokens(tk)
			else:
				with open(path, 'r') as f:
					cnt = process_tokens(tokenize.generate_tokens(f.readline))
		else:
			with open(path, 'r') as f:
				cnt = f.read()
		# WARNING: since python >= 2.5 is required, decorators are not processed anymore
		# uncomment the following to enable decorator replacement:
		#cnt = process_decorators(cnt)
		#if cnt.find('set(') > -1:
		#	cnt = 'import sys\nif sys.hexversion < 0x020400f0: from sets import Set as set\n' + cnt
		cnt = '#! /usr/bin/env python\n# encoding: utf-8\n# WARNING! Do not edit! https://waf.io/book/index.html#_obtaining_the_waf_file\n\n' + cnt

	else:
		with open(path, 'r') as f:
			cnt = f.read()

	if sys.hexversion > 0x030000f0:
		return (io.BytesIO(cnt.encode('utf-8')), len(cnt.encode('utf-8')), cnt)
	return (io.BytesIO(cnt), len(cnt), cnt)

def create_waf(self, *k, **kw):
	mw = 'tmp-waf-'+VERSION
	print('-> preparing %r' % mw)

	import tarfile, zipfile

	zipType = Options.options.zip.strip().lower()
	if zipType not in zip_types:
		zipType = zip_types[0]

	directory_files = {}
	files = []
	add3rdparty = []
	for x in Options.options.add3rdparty.split(','):
		if os.path.isdir(x):
			# Create mapping from files absolute path to path in module
			# directory (for module mylib):
			#
			#     {"/home/path/mylib/__init__.py": "mylib/__init__.py",
			#      "/home/path/mylib/lib.py": "mylib/lib.py",
			#      "/home/path/mylib/sub/sub.py": "mylib/sub/lib.py"
			#     }
			#
			x_dir = self.generator.bld.root.find_dir(
				os.path.abspath(os.path.expanduser(x)))

			file_list = x_dir.ant_glob('**/*.py')

			for f in file_list:

				file_from = f.abspath()
				file_to = os.path.join(x_dir.name, f.path_from(x_dir))

				# If this is executed on Windows, then file_to will contain
				# '\' path separators. These should be changed to '/', otherwise
				# the added tools will not be accessible on Unix systems.
				directory_files[file_from] = file_to.replace('\\', '/')
				files.append(file_from)

		elif os.path.isabs(x):
			files.append(x)
		else:
			add3rdparty.append(x + '.py')

	coretools = []
	for x in Options.options.coretools.split(','):
		coretools.append(x + '.py')

	up_node = self.generator.bld.path
	for node in up_node.find_dir('waflib').ant_glob(incl=['*.py', 'Tools/*.py', 'extras/*.py']):
		relpath = node.path_from(up_node)
		if node.name == '__init__.py':
			files.append(relpath)
			continue
		if node.parent.name == 'Tools' and Options.options.coretools != 'default':
			if node.name not in coretools:
				continue
		if node.parent.name == 'extras':
			if node.name not in add3rdparty:
				continue
		files.append(relpath)

	if Options.options.namesfrom:
		with tarfile.open(Options.options.namesfrom) as tar:
			oldfiles = files
			files = [x.name for x in tar.getmembers()]
			if set(files) ^ set(oldfiles):
				Logs.warn('The archive model has differences:')
				Logs.warn('- Added %r', list(set(files) - set(oldfiles)))
				Logs.warn('- Removed %r', list(set(oldfiles) - set(files)))

	#open a file as tar.[extension] for writing
	tar = tarfile.open('%s.tar.%s' % (mw, zipType), "w:%s" % zipType)
	z = zipfile.ZipFile("zip/waflib.zip", "w", compression=zipfile.ZIP_DEFLATED)
	for x in files:
		try:
			tarinfo = tar.gettarinfo(x, x)
		except NotImplementedError:
			# jython 2.7.0 workaround
			tarinfo = tarfile.TarInfo(x)
		tarinfo.uid   = tarinfo.gid   = 0
		tarinfo.uname = tarinfo.gname = 'root'
		if os.environ.get('SOURCE_DATE_EPOCH'):
			tarinfo.mtime = int(os.environ.get('SOURCE_DATE_EPOCH'))
		(code, size, cnt) = sfilter(x)
		tarinfo.size = size

		if x in directory_files:
			tarinfo.name = 'waflib/extras/' + directory_files[x]
		elif os.path.isabs(x):
			tarinfo.name = 'waflib/extras/' + os.path.split(x)[1]

		print('   adding %s as %s' % (x, tarinfo.name))
		def dest(x):
			if x in directory_files:
				return os.path.join('waflib', 'extras', directory_files[x])
			elif os.path.isabs(x):
				return os.path.join('waflib', 'extras', os.path.basename(x))
			else:
				return os.path.normpath(os.path.relpath(x, "."))

		z.write(x, dest(x))
		tar.addfile(tarinfo, code)
	tar.close()
	z.close()

	with open('waf-light', 'r') as f:
		code1 = f.read()

	# tune the application name if necessary
	if Options.options.wafname != 'waf':
		Options.options.prelude = '\tfrom waflib import Context\n\tContext.WAFNAME=%r\n' % Options.options.wafname + Options.options.prelude

	# now store the revision unique number in waf
	code1 = code1.replace("if sys.hexversion<0x206000f:\n\traise ImportError('Python >= 2.6 is required to create the waf file')\n", '')
	code1 = code1.replace('\t#import waflib.extras.compat15#PRELUDE', Options.options.prelude)

	# when possible, set the git revision in the waf file
	bld = self.generator.bld
	try:
		rev = bld.cmd_and_log('git rev-parse HEAD', quiet=0).strip()
	except Errors.WafError:
		rev = ''
	else:
		reg = re.compile('^GIT(.*)', re.M)
		code1 = reg.sub('GIT="%s"' % rev, code1)

	# if the waf file is installed somewhere... but do not do that
	prefix = ''
	reg = re.compile('^INSTALL=(.*)', re.M)
	code1 = reg.sub(r'INSTALL=%r' % prefix, code1)
	#change the tarfile extension in the waf script
	reg = re.compile('bz2', re.M)
	code1 = reg.sub(zipType, code1)
	if zipType == 'gz':
		code1 = code1.replace('bunzip2', 'gzip -d')
	elif zipType == 'xz':
		code1 = code1.replace('bunzip2', 'xz -d')

	with open('%s.tar.%s' % (mw, zipType), 'rb') as f:
		cnt = f.read()

	# the REVISION value is the md5 sum of the compressed data (facilitate audits)
	m = md5()
	m.update(cnt)
	REVISION = m.hexdigest()
	reg = re.compile('^REVISION=(.*)', re.M)
	code1 = reg.sub(r'REVISION="%s"' % REVISION, code1)

	def find_unused(kd, ch):
		for i in range(35, 125):
			for j in range(35, 125):
				if i==j: continue
				if i == 39 or j == 39: continue
				if i == 92 or j == 92: continue
				s = chr(i) + chr(j)
				if -1 == kd.find(s.encode()):
					return (kd.replace(ch.encode(), s.encode()), s)
		raise ValueError('Could not find a proper encoding')

	# The reverse order prevents collisions
	(cnt, C3) = find_unused(cnt, '\x00')
	(cnt, C2) = find_unused(cnt, '\r')
	(cnt, C1) = find_unused(cnt, '\n')
	ccc = code1.replace("C1='x'", "C1='%s'" % C1).replace("C2='x'", "C2='%s'" % C2).replace("C3='x'", "C3='%s'" % C3)

	if getattr(Options.options, 'interpreter', None):

=== demos/csharp/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2010 (ita)

FRAG = '''
namespace Moo {
	public class Test {
		public static int Main(string[] args) {
			return 0;
		}
	}
}
'''

def options(opt):
	opt.load('cs')

def configure(conf):
	conf.load('cs')
	try:
		conf.check(features='cs', fragment=FRAG, compile_filename='test.cs', gen='test.exe',
			csflags=['-pkg:gtk-sharp-2.0'], msg='Checking for Gtksharp support')
		conf.env.HAS_GTKSHARP = True
	except conf.errors.ConfigurationError:
		conf.env.HAS_GTKSHARP = False

def build(bld):

	# for system libraries, use:
	#bld.read_csshlib('ManagedLibrary.dll', paths=[bld.env.mylibrarypath])

	bld(features='cs', source='My.cs Dye.cs', gen='my.dll', name='mylib', csdebug='full')
	bld(features='cs', source='Hi.cs', includes='.', gen='hi.exe', use='mylib', name='hi')
	bld(features='cs', source='Hi.cs', includes='.', gen='hi-x86.exe', use='mylib', name='hi', platform='x86')
	if bld.env.HAS_GTKSHARP:
		bld(features='cs', source='Simple.cs', includes='.', gen='mono-hello.exe', csflags=['-pkg:gtk-sharp-2.0'])

	# note:
	# bld(features='cs', ..., type='module' # or exe, library, winexe, ...

=== demos/d/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2006 (ita)

VERSION='0.0.1'
APPNAME='d_test'

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_d')

def configure(conf):
	# why does dmd require -fPIC on everything?
	conf.env.DFLAGS='-fPIC'
	conf.load('compiler_d')
	conf.env.LIB_PTHREAD = ['pthread']
	conf.check_dlibrary()
	try:
		conf.check(features='d dprogram', fragment='int main() {return 0;}', compile_filename='test.d', dflags=['-version=Posix'])
	except:
		pass
	else:
		conf.env.append_value('DFLAGS', ['-version=Posix'])

def build(bld):

	if bld.env.DLIBRARY != 'tango':
		bld.recurse('src')

		# here is how to use the object-oriented notation
		bld.stlib(
			source   = 'testlib/code.d',
			includes = '.',
			name     = 'testlib',
			target   = 'testlib')

		bld.program(
			source   = 'example.d',
			target   = 'd_test',
			use      = 'testlib PTHREAD',
			includes = '.')

	else:
		# bad pun hidden
		bld.program(source='foo.d', target='bar', use='hmm', includes=[bld.path])
		bld.stlib(source='hmm.d', target='hmm')

		#bld(features='d dshlib', source='shared.d', target='sha')
		# shared libs do not work here:
		# ldc -relocation-model=pic -L-shared shared.d -offoo
		# /usr/lib64/gcc/x86_64-suse-linux/4.5/../../../../x86_64-suse-linux/bin/ld:
		# /disk/comp/ldc/bin/../lib/libtango.a(tango-core-rt-compiler-ldc-object_-O2.o):
		# relocation R_X86_64_32 against `.rodata.str1.1' can not be used when making a shared object; recompile with -fPIC

=== demos/jni/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Zellman 2009

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_c')
	opt.load('java')

def configure(conf):
	conf.load('compiler_c')
	conf.load('java')

	conf.check_jni_headers()

def build(bld):
	bld(features='javac jar', srcdir='src/java', outdir='src/java', basedir='src/java', destfile='stringUtils.jar')

	bld.shlib(
		source   = 'src/jni/source/StringUtils.c',
		includes = 'src/jni/include',
		target   = 'stringUtils',
		uselib   = 'JAVA')

=== demos/precious/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def options(opt):
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c')

def build(bld):

	# the file precious.c is updated in the source directory
	# the actual application is produced in the build directory

	node = bld.path.find_resource('precious.c')

	def fun(task):
		import random
		val = random.randint(0, 222111000)
		task.outputs[0].write('#include <stdio.h>\nint main(){ printf("%%d", %d); return 0;}' % val)

	bld(
		#rule = '''echo -e "#include <stdio.h>\\nint main(){ printf(\\"%%d\\", $$RANDOM); return 0;}" > ${TGT}''',
		rule = fun,
		target = node,
		always = True)

	bld.program(
		source = 'precious.c',
		target = 'app')

=== demos/unit_test/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Richard Quirk, 2008

"""
Execute tests during the build - requires cppunit

To force all tests, run with "waf build --alltests"
"""

from waflib.Tools import waf_unit_test

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_cxx')
	opt.load('waf_unit_test')

def configure(conf):
	conf.load('compiler_cxx')
	conf.load('waf_unit_test')

	# the demo files require cppunit - but the waf tool does not
	conf.check_cfg(package='cppunit', args='--cflags --libs', mandatory=True)
	if 'dl' not in conf.env.LIB_CPPUNIT:
		l = conf.check(lib='dl', uselib_store='CPPUNIT')

	# the interpreted tests need python
	conf.find_program('python', mandatory=False)

from waflib import Logs
def summary(bld):
	lst = getattr(bld, 'utest_results', [])
	if lst:
		total = len(lst)
		tfail = len([x for x in lst if x[1]])

		val = 100 * (total - tfail) / (1.0 * total)
		Logs.pprint('CYAN', 'test report %3.0f%% success' % val)

		Logs.pprint('CYAN', '  tests that fail %d/%d' % (tfail, total))
		for result in lst:
			if result.exit_code:
				# In ut_task we have the task running the test and we can get any extra information
				# from there (in this example just the generator name)
				Logs.pprint('CYAN', '    %s (%s)' % (result.test_path, result.generator.name))
				Logs.pprint('RED', 'status: %r' % result.exit_code)
				if result.out:
					Logs.pprint('RED', 'out: %r' % result.out)
				if result.err:
					Logs.pprint('RED', 'err: %r' % result.err)

def build(bld):
	bld.recurse('src tests')

	# waf_unit_test.summary is a pretty ugly function for displaying a report (feel free to improve!)
	# results -> bld.utest_results [(filename, returncode, stdout, stderr), (..., ), ...]
	#bld.add_post_fun(waf_unit_test.summary)
	bld.add_post_fun(summary)

	# to execute all tests:
	# $ waf --alltests
	# to set this behaviour permanently:
	#bld.options.all_tests = True
	bld.options.clear_failed_tests = True

	# debugging zone:
	# $ waf --zones=ut
	# setting the cwd for a unit test execution: see tests/test1/wscript_build (ut_cwd)

=== playground/boost_log/wscript ===
top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_cxx boost')

def configure(conf):
	conf.load('compiler_cxx boost')

	if conf.options.boost_mt:
		conf.check_boost('system thread log log_setup')
	else:
		conf.check_boost('log log_setup')

def build(bld):
	bld.program(source='main.cpp', target='app', use='BOOST')

=== playground/c/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2006-2010 (ita)

VERSION='0.0.1'
APPNAME='cc_test'

top = '.'

import waflib.Configure
waflib.Configure.autoconfig = True

def options(opt):
	opt.load('compiler_c')
	opt.load('gnu_dirs')

def build(bld):
	bld.recurse('program stlib shlib stlib2')


lst = 'debug release foo bar one two'.split()

def configure(conf):
	conf.load('compiler_c')
	conf.check_features()
	conf.check_cc(fragment="""#include<stdio.h>\nint main(){fprintf(stderr, "mu"); printf("%d", 22);return 0;}\n""", execute=True, define_name='HAVE_MU')
	conf.write_config_header('config.h')

	# gotcha - the config.h must be written for each variant
	for x in lst:
		conf.write_config_header(x + '/config.h')

from waflib import Utils, Build
class buildall_ctx(Build.BuildContext):
	cmd = fun = 'buildall'
	def compile(self):
		pass

def buildall(ctx):
	"""call 'waf buildall' to build all the variants in parallel"""

	timer = Utils.Timer()
	threads = []
	count = [0]
	line_lock = Utils.threading.Lock()
	class sub_build(Utils.threading.Thread):
		def run(self):
			bld = self.bld = self.cls(top_dir=ctx.top_dir, out_dir=ctx.out_dir)
			bld.restore()
			bld.siblings = threads
			bld.count = count
			bld.line_lock = line_lock
			bld.timer = timer
			bld.logger = ctx.logger
			bld.load_envs()
			bld.targets = ctx.targets
			bld.recurse([bld.run_dir])
			bld.compile()

	for x in lst:
		cls = type(Build.BuildContext)(x, (Build.BuildContext,), {'cmd': x, 'variant': x})
		cls.progress_line = locked_progress_line
		f = sub_build()
		f.cls = cls
		threads.append(f)
		f.start()

	for x in threads:
		x.join()

def locked_progress_line(self, state, total, col1, col2):
	try:
		self.line_lock.acquire()
		self.count[0] += 1
		total = 0
		for x in self.siblings:
			try:
				p = x.bld.producer
			except AttributeError:
				pass
			else:
				total += p.total

		return Build.BuildContext.progress_line(self, self.count[0], total, col1, col2)
	finally:
		self.line_lock.release()

class cleanall_ctx(Build.CleanContext):
	cmd = fun = 'cleanall'

def cleanall(ctx):
	for x in lst:
		cls = type(Build.CleanContext)(x, (Build.CleanContext,), {'cmd': x, 'variant': x})
		bld = cls(top_dir=ctx.top_dir, out_dir=ctx.out_dir)
		bld.restore()
		bld.load_envs()
		bld.recurse([bld.run_dir])
		try:
			bld.clean()
		finally:
			bld.store()


# produces dict/json compatible output
features_str = r'''
#include <stdio.h>
int is_big_endian()
{
	long one = 1;
	return !(*((char *)(&one)));
}
int main()
{
	printf("{");
	if (is_big_endian()) printf("\"bigendian\":1,");
	else printf("\"bigendian\":0,");
	printf("\"int_size\":%lu,", sizeof(int));
	printf("\"long_int_size\":%lu,", sizeof(long int));
	printf("\"long_long_int_size\":%lu,", sizeof(long long int));
	printf("\"double_size\":%lu", sizeof(double));
	printf("}");
	return 0;
}
'''

def check_features(self):

	mp = self.check(fragment=features_str, define_ret=True, execute=True)
	try:
		mp = mp.decode('utf-8')
	except:
		pass


	t = eval(mp)
	try:
		is_big = int(t['bigendian'])
	except KeyError:
		raise Configure.ConfigurationError('endian test failed %s (see the config.log)' % features_str)

	if is_big: strbig = 'big endian'
	else: strbig = 'little endian'
	self.msg('endianness', strbig)

	self.msg('int size', t['int_size'])
	self.msg('long int size', t['long_int_size'])
	self.msg('long long int size', t['long_long_int_size'])
	self.msg('double size', t['double_size'])

	self.define_cond('IS_BIGENDIAN', is_big)
	self.define_cond('INT_SIZE', int(t['int_size']))
	self.define_cond('LONG_INT_SIZE', int(t['long_int_size']))
	self.define_cond('LONG_LONG_INT_SIZE', int(t['long_long_int_size']))
	self.define_cond('DOUBLE_SIZE', int(t['double_size']))

	return is_big

from waflib import Configure
Configure.conf(check_features) # bind the method

=== playground/cfg_cache/wscript ===
#! /usr/bin/env python

"""
compare the execution time of
waf configure
and
waf configure --confcache
"""

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_c')
	opt.add_option('--confcache', dest='confcache', default=0, action='count', help='Use a configuration cache')

def configure(conf):
	conf.load('compiler_c')
	conf.check(fragment='int main() { return 0; }')

=== playground/cpplint/wscript ===
top = '.'
out = 'build'

def options(opt):
    opt.load('compiler_cxx cpplint')

def configure(conf):
    conf.load('compiler_cxx cpplint')

def build(bld):
    bld(features='cpplint', source='my_include.hpp')
    bld.program(features='cpplint', source='main.cpp', target='app')

=== playground/descriptions/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Justin Israel, 2017 

"""
Allow the "waf list" command to display descriptions for each target
"""

top = '.'
out = 'build'

def configure(ctx):
	pass

def build(bld):
	bld(
		rule="touch ${TGT}",
		target='file.in',
		description='Create the input file',
	)

	bld(
		rule='cp ${SRC} ${TGT}',
		source='file.in',
		target='file.out',
		description='Generate output file',
	)

	bld.install_files(
		'dist',
		['file.out'],
		name='install',
		description='Deploy files',
	)

=== playground/dynamic_headers/wscript ===
#! /usr/bin/env python

from waflib import Task, Errors
from waflib.Tools import c

def options(opt):
	opt.load('compiler_c')


def configure(conf):
	conf.load('compiler_c')


def build(bld):
	bld(features = 'c cprogram',
		target   = 'test',
		source   = 'src/main.c src/test.c',
		includes = 'src')

class mock(Task.Task):
	run_str = 'cp ${SRC} ${TGT}'
	color   = 'BLUE'


# it would be better to replace the scan() method, but this is doable too

def runnable_status(self):

	ret = self.runnable_status_dynamic_headers2()

	if ret != Task.ASK_LATER and not getattr(self, 'all_mock_done', False):
		self.all_mock_done = True # run once


		bld = self.generator.bld
		add = False

		try:
			mock_tasks = bld.mock_tasks
		except AttributeError:
			mock_tasks = bld.mock_tasks = {}

		for x in bld.raw_deps[self.uid()]:
			if x.startswith('mock_'):
				h_file = x[5:]
				for k in [self.inputs[0].parent] + self.generator.includes_nodes:
					h_node = k.find_node(h_file)
					if h_node:
						break

				if not h_node:
					raise Errors.WafError('no header for %s' % x)

				m_node = h_node.parent.find_or_declare(x)
				try:
					tsk = mock_tasks[m_node]
				except KeyError:
					tsk = mock_tasks[m_node] = self.generator.create_task('mock', [h_node], [m_node])
					bld.producer.outstanding.append(tsk)
					bld.producer.total += 1

					# preprocessor cache :-/
					try:
						for key in list(bld.cache_nd.keys()):
							if key[1] == x:
								del bld.cache_nd[key]
					except (KeyError, AttributeError):
						pass

				add = True
				self.set_run_after(tsk)

		if add:
			# recompute the task signature
			delattr(self, 'cache_sig')
			del bld.imp_sigs[self.uid()]
			return self.runnable_status()

		for x in bld.node_deps[self.uid()]:
			if x.name.startswith('mock_'):
				h_node = x.parent.get_src().find_node(x.name[5:])
				if not h_node:
					raise Errors.WafError('no header for %s' % x.name)

				try:
					tsk = mock_tasks[x]
				except KeyError:
					tsk = mock_tasks[x] = self.generator.create_task('mock', [h_node], [x])
					bld.producer.outstanding.append(tsk)
					bld.producer.total += 1

				add = True
				self.set_run_after(tsk)

				# node get_bld_sig cache :-/
				try:
					delattr(x, 'cache_sig')
				except AttributeError:
					pass
		if add:
			# recompute the task signature
			delattr(self, 'cache_sig')
			return self.runnable_status()

	return ret

c.c.runnable_status_dynamic_headers2 = c.c.runnable_status
c.c.runnable_status = runnable_status

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=waf
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2.1.5
pkgrel=1
pkgdesc="General-purpose build system modelled after Scons (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://waf.io/"
msys2_repository_url="https://gitlab.com/ita1024/waf"
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-python")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
options=('!emptydirs')
source=("https://waf.io/${_realname}-${pkgver}.tar.bz2"{,.asc})
validpgpkeys=('8AF22DE5A06822E3474F3C7049B4C67C05277AAA'
              '0B3972B2D9E32EAB423D2E0F22BE0C62FFBFA548'  # "Thomas Nagy <tnagy@waf.io>"
              '8C7EB2F93B0C45F5732FE5D11BAC571DCD772295') # Waf Project <noreply@waf.io>
sha256sums=('ca23407fe8169c9ca8c439fcc8ac143230da056678df279220ebf0c10091678a'
            'SKIP')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # Extract license
  head -n 30 waf-light | tail -n 25 > LICENSE
}

build() {
  cd "${srcdir}/${_realname}-${pkgver}"
  plain "Configure ..."
  ${MINGW_PREFIX}/bin/python ./waf-light configure --prefix=${MINGW_PREFIX}
  plain "Make waf ..."
  ${MINGW_PREFIX}/bin/python ./waf-light --make-waf
}

package() {
  cd "${srcdir}/${_realname}-${pkgver}"

  prelude=$(cat <<'EOF'
	import waflib.Tools.compiler_c, waflib.Tools.compiler_cxx
	waflib.Tools.compiler_c.c_compiler['win32'] = ['gcc', 'clang', 'msvc']
	waflib.Tools.compiler_cxx.cxx_compiler['win32'] = ['g++', 'clang++', 'msvc']
EOF
  )

  ${MINGW_PREFIX}/bin/python ./waf-light install -f --destdir="${pkgdir}" \
    --prelude="${prelude}" \
    --tools='compat,compat15,ocaml,go,cython,scala,erlang,cuda,gcj,boost,pep8,eclipse,unity,clang_compilation_database'

  install -Dm755 waf "${pkgdir}${MINGW_PREFIX}/bin/waf"
  install -Dm755 waf.bat "${pkgdir}${MINGW_PREFIX}/bin/waf.bat"

  # Force the generation of .waf.admin files
  cd "${srcdir}/${_realname}-${pkgver}/demos/c"
  CC_NAME=${CC} CC="${MINGW_PREFIX}/bin/${CC}.exe" \
  CXX_NAME=${CXX} CXX="${MINGW_PREFIX}/bin/${CXX}.exe" \
  "${pkgdir}${MINGW_PREFIX}/bin/waf" configure build

  # Fix weird directory placement (FS#38216, FS#38300)
  mkdir -p "${pkgdir}${MINGW_PREFIX}/lib/waf"
  mv "${pkgdir}${MINGW_PREFIX}/bin/waf3-${pkgver}-"* "${pkgdir}${MINGW_PREFIX}/lib/waf/"
  sed -s "s|INSTALL=''|INSTALL='${MINGW_PREFIX}/lib/waf'|g" -i "${pkgdir}${MINGW_PREFIX}/bin/waf"

  cd "${srcdir}/${_realname}-${pkgver}"
  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
